module TB_alu_top;
   reg [7:0] f, k, w;
   reg 	     carry_in;
   reg op_addwf,
       op_andwf,
       op_clrf,
       op_clrw,
       op_comf,
       op_decf,
       op_decfsz,
       op_incf,
       op_incfsz,
       op_iorwf,
       op_movf,
       op_movwf,
       op_rlf,
       op_rrf,
       op_subwf,
       op_swapf,
       op_xorwf,
       
       op_bcf,
       op_bsf,
       op_btfsc,
       op_btfss,
	       
       op_andlw,
       op_iorlw,
       op_movlw,
       op_retlw,
       op_xorlw;
   wire [7:0] alu_out;
   wire       zero_out, dc_out, carry_out;

   alu_top u(f, k, w, 
	     carry_in, 
	     op_addwf,
	     op_andwf,
	     op_clrf,
	     op_clrw,
	     op_comf,
	     op_decf,
	     op_decfsz,
	     op_incf,
	     op_incfsz,
	     op_iorwf,
	     op_movf,
	     op_movwf,
	     op_rlf,
	     op_rrf,
	     op_subwf,
	     op_swapf,
	     op_xorwf,
	     
	     op_bcf,
	     op_bsf,
	     op_btfsc,
	     op_btfss,
	     
	     op_andlw,
	     op_iorlw,
	     op_movlw,
 	     op_retlw,
	     op_xorlw,
	     

	     alu_out,
	     zero_out,
	     dc_out,
	     carry_out);
   

   initial  begin
      op_addwf=0;
      op_andwf=0;
      op_clrf=0;
      op_clrw=0;
      op_comf=0;
      op_decf=0;
      op_decfsz=0;
      op_incf=0;
      op_incfsz=0;
      op_iorwf=0;
      op_movf=0;
      op_movwf=0;
      op_rlf=0;
      op_rrf=0;
      op_subwf=0;
      op_swapf=0;
      op_xorwf=0;
      
      op_bcf=0;
      op_bsf=0;
      op_btfsc=0;
      op_btfss=0;
      
      op_andlw=0;
      op_iorlw=0;
      op_retlw=0;
      op_xorlw=0;
      

      op_movlw = 1;
      w = 1;
      f=2;
      k=1;
      
      #30
	op_movlw =0;
	op_movwf = 1;
      #30 op_movwf = 0;
      op_incf = 1;
      
      #30 op_incf=0;
      op_incf =1;
      
   end

   always @(alu_out or
	    zero_out or 
	    dc_out or
	    carry_out)
     $display($time,,,"alu:%d z:%d dc:%d c:%d", alu_out, zero_out, dc_out, carry_out);
   
   
endmodule // alu_top_TB

   
       
   
   