module TB_reg_fsr;
   reg clk, reset, fwe;
   reg [4:0] fsel;
   reg [7:0] fin;

   wire [7:0] fsr;

   reg [7:0]  d;
   reg_fsr u(clk, reset, fsel, fwe, fin, fsr);
   
   initial begin
      reset = 0;
      fwe=1;
      fsel = 5'b00100;
      fin = 8'b0000_0000;
      d= 8'b0000_0000;
      #2 reset =1;
      #2 reset =0;
   end
      
   always begin
      #10 clk = 0;
      d=d+1;
      #10 clk =1;
   end

   always @(negedge clk) begin
      if(d % 2 == 0) fwe <= 1;
      else fwe <= 0;
      fin <= d;
   end

   always @(fwe or fin or fsr) begin
      $display($time,,,"fwe:%d fin %d fsr:%d", fwe, fin, fsr);
   end
   
endmodule // TB_reg_fsr

     