/*
 * PIC16C5x compatible processor
 * 
 * 
 *               Park, Chunghoon(shyfool@hanmail.net)
 *           High-Speed Digital Circuit Lab in Kyungpook National University
 * 
 * 
 * This is based on Ans_Risc_Core8(VHDL)(http://www.anslab.co.kr)
 * 
 * YOU CAN USE FREELY WITH YOUR OWN RISK
 * -------------------------------------
 */

module alu_op_gen(op_addwf,
		  op_andwf,
		  op_clrf,
		  op_clrw,
		  op_comf,
		  op_decf,
		  op_decfsz,
		  op_incf,
		  op_incfsz,
		  op_iorwf,
		  op_movf,
		  op_movwf,
		  op_rlf,
		  op_rrf,
		  op_subwf,
		  op_swapf,
		  op_xorwf,
	      
		  op_bcf,
		  op_bsf,
		  op_btfsc,
		  op_btfss,
	      
		  op_andlw,
		  op_iorlw,
		  op_movlw,
 		  op_retlw,
		  op_xorlw,
		  alu_op
		  );
   input op_addwf,
	 op_andwf,
	 op_clrf,
	 op_clrw,
	 op_comf,
	 op_decf,
	 op_decfsz,
	 op_incf,
	 op_incfsz,
	 op_iorwf,
	 op_movf,
	 op_movwf,
	 op_rlf,
	 op_rrf,
	 op_subwf,
	 op_swapf,
	 op_xorwf,
	 
	 op_bcf,
	 op_bsf,
	 op_btfsc,
	 op_btfss,
	      
	 op_andlw,
	 op_iorlw,
	 op_movlw,
 	 op_retlw,
	 op_xorlw;

   output [3:0] alu_op;

   parameter [3:0] 	ALU_ADD = 4'b0000;
   parameter [3:0] 	ALU_SUB = 4'b0001;
   parameter [3:0] 	ALU_AND = 4'b0010;
   parameter [3:0] 	ALU_OR = 4'b0011;
   parameter [3:0] 	ALU_XOR = 4'b0100;
   parameter [3:0] 	ALU_COM = 4'b0101;
   parameter [3:0] 	ALU_RR = 4'b0110;
   parameter [3:0] 	ALU_RL = 4'b0111;
   parameter [3:0] 	ALU_SWAP =4'b1000;
   parameter [3:0] 	ALU_BC   =4'b1001;
   parameter [3:0] 	ALU_BS   =4'b1010;
   parameter [3:0] 	ALU_BTC = 4'b1011;
   parameter [3:0] 	ALU_BTS = 4'b1100;

   assign 		alu_op = 
			(op_addwf == 1 ||op_incf ==1 || op_incfsz == 1) ? 
			  ALU_ADD:
			(op_subwf == 1|| op_decf == 1 || op_decfsz == 1) ? 
			ALU_SUB  :
			(op_andlw == 1|| op_andwf == 1) ? 
			ALU_AND :
			(op_iorwf == 1|| op_iorlw == 1|| op_movwf==1 || op_movf==1 || op_movlw==1 || op_retlw==1) ? 
			ALU_OR :
			(op_xorwf==1 || op_xorlw==1 || op_clrw==1 || op_clrf==1) ? 
			ALU_XOR :
			(op_comf==1) ? ALU_COM :
			(op_rrf==1) ? ALU_RR:
			(op_rlf==1) ? ALU_RL:
			(op_swapf==1) ?  ALU_SWAP:
			(op_bcf==1) ? ALU_BC:
			(op_bsf==1) ? ALU_BS:
			(op_btfsc==1) ? ALU_BTC:
			(op_btfss == 1) ? ALU_BTS:
			4'b1111;
endmodule
	 
