/*
 * PIC16C5x compatible processor
 * 
 * 
 *               Park, Chunghoon(shyfool@hanmail.net)
 *           High-Speed Digital Circuit Lab in Kyungpook National University
 * 
 * 
 * This is based on Ans_Risc_Core8(VHDL)(http://www.anslab.co.kr)
 * 
 * YOU CAN USE FREELY WITH YOUR OWN RISK
 * -------------------------------------
 */

module mux_alu_a(f, 
		 k, 
		 w,
		 op_comf,
		 op_decf,
		 op_decfsz,
		 op_incf,
		 op_incfsz,
		 op_movf,
		 op_rlf,
		 op_rrf,
		 op_subwf,
		 op_swapf,
		 
		 op_bcf,
		 op_bsf,
		 op_btfsc,
		 op_btfss,
	      
		 op_andlw,
		 op_iorlw,
		 op_movlw,
		 op_retlw,
		 op_xorlw,
		 
		 alu_a
		 );
   input [7:0] f, k, w;
   input       op_comf,
	       op_decf,
	       op_decfsz,
	       op_incf,
	       op_incfsz,
	       op_movf,
	       op_rlf,
	       op_rrf,
	       op_subwf,
	       op_swapf,
	       op_bcf,
	       op_bsf,
	       op_btfsc,
	       op_btfss,
	       op_andlw,
	       op_iorlw,
	       op_movlw,
	       op_retlw,
	       op_xorlw;
   output [7:0] alu_a;
   
   assign 	alu_a = 
		(op_subwf == 1 || 
		 op_decf == 1 || 
		 op_movf == 1 ||
		 op_comf == 1 ||
		 op_incf == 1 ||
		 op_decfsz == 1 ||
		 op_rrf == 1 ||
		 op_rlf == 1 ||
		 op_swapf == 1 ||
		 op_incfsz == 1 ||
		 op_bcf == 1 ||
		 op_bsf == 1 ||
		 op_btfsc == 1 ||
		 op_btfss == 1) ? f:
		(op_movlw == 1|| 
		 op_iorlw == 1||
		 op_andlw == 1||
		 op_xorlw == 1||
		 op_retlw == 1) ? k : w;
endmodule // mux_alu_a


