/*
 * PIC16C5x compatible processor
 * 
 * 
 *               Park, Chunghoon(shyfool@hanmail.net)
 *           High-Speed Digital Circuit Lab in Kyungpook National University
 * 
 * 
 * This is based on Ans_Risc_Core8(VHDL)(http://www.anslab.co.kr)
 * 
 * YOU CAN USE FREELY WITH YOUR OWN RISK
 * -------------------------------------
 */

module reg_fsr(clk,
	       reset,
	       fsel,
	       fwe,
	       fin,

	       fsr);
   input clk,
	 reset,
	 fwe;
   input [4:0] fsel;
   input [7:0] fin;

   output [7:0] fsr;

   reg [7:0] 	fsr;

   always @(posedge clk or posedge reset) begin
      if(reset == 1)
	fsr <= 8'b0000_0000;
      else
	if(fwe == 1 && fsel ==5'b00100)
	  fsr <= fin;
   end
endmodule // reg_fsr

