/*
 * PIC16C5x compatible processor
 * 
 * 
 *               Park, Chunghoon(shyfool@hanmail.net)
 *           High-Speed Digital Circuit Lab in Kyungpook National University
 * 
 * 
 * This is based on Ans_Risc_Core8(VHDL)(http://www.anslab.co.kr)
 * 
 * YOU CAN USE FREELY WITH YOUR OWN RISK
 * -------------------------------------
 */

module reg_mux_f(alu_out,
		 fout,
		 d,

		 op_clrf,
		 op_movwf,
		 op_bcf,
		 op_bsf,
		 op_subwf,
		 op_decf,
		 op_iorwf,
		 op_andwf,
		 op_xorwf,
		 op_addwf,
		 op_movf,
		 op_comf,
		 op_incf,
		 op_decfsz,
		 op_rrf,
		 op_rlf,
		 op_swapf,
		 op_incfsz,

		 f);
   input [7:0] alu_out, fout;

   input       d;
   input       op_clrf,
	       op_movwf,
	       op_bcf,
	       op_bsf,
	       op_subwf,
	       op_decf,
	       op_iorwf,
	       op_andwf,
	       op_xorwf,
	       op_addwf,
	       op_movf,
	       op_comf,
	       op_incf,
	       op_decfsz,
	       op_rrf,
	       op_rlf,
	       op_swapf,
	       op_incfsz;
   
   output [7:0] f;


   assign f = 
	  ((op_clrf == 1) ||
	  (op_movwf == 1) ||
	  (op_subwf == 1 && d == 1) ||
	  (op_decf == 1  && d == 1) ||
	  (op_iorwf == 1 && d == 1 ) ||
	  (op_andwf == 1 && d == 1 ) ||
	  (op_xorwf == 1 && d == 1) ||
	  (op_addwf == 1 && d == 1 ) ||
	  (op_movf == 1 && d == 1) ||
	  (op_comf == 1 && d == 1) ||
	  (op_incf == 1 && d == 1) ||
	  (op_decfsz == 1 && d == 1) ||
	  (op_rrf == 1 && d == 1) ||
	  (op_rlf == 1 && d == 1) ||
	  (op_swapf == 1 && d == 1) ||
	  (op_bcf == 1) ||
	  (op_bsf == 1) ||
	  (op_incfsz == 1 && d == 1)) ? alu_out: fout;

endmodule // reg_mux_f
