/*
 * PIC16C5x compatible processor
 * 
 * 
 *               Park, Chunghoon(shyfool@hanmail.net)
 *           High-Speed Digital Circuit Lab in Kyungpook National University
 * 
 * 
 * This is based on Ans_Risc_Core8(VHDL)(http://www.anslab.co.kr)
 * 
 * YOU CAN USE FREELY WITH YOUR OWN RISK
 * -------------------------------------
 */

module reg_status(clk,
		  reset,

		  c_write,
		  z_write,

		  alu_carry,
		  alu_dc,
		  alu_z,

		  fwe,
		  fsel,

		  fin,

		  status);
   input clk,
	 reset,

	 c_write,
	 z_write,

	 alu_carry,
	 alu_dc,
	 alu_z,

	 fwe;

   input [4:0] fsel;
   input [7:0] fin;
   output [7:0] status;

   reg [7:0] 	status;
   
   always @(posedge clk or posedge reset) begin
      if(reset == 1)
	status <=8'b0000_0000;
      else begin
	 if(fwe == 1 && fsel == 5'b00011) begin
	    status <= fin;
	 end
	 else begin
	    if(c_write == 1)
	      status[0] <= alu_carry;
	    if(z_write == 1)
	      status[2] <= alu_z;
	 end
      end
   end // always @ (posedge clk or posedge reset)

endmodule // reg_status

		  
		  
   